{
  This sample shows how to load an ACE file and save it as a .BMP.
  1/31/2002
}
unit AceToBmpFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, AceFile, ExtCtrls, SctVar, SctCtrl, SctRep;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    btnOpenAceFile: TBitBtn;
    radgrp: TRadioGroup;
    SctReport1: TSctReport;
    ReportPage: TSctGrouppage;
    ReportHeaderBand: TSctBand;
    ReportHeaderBandlevel: TSctLevel;
    PageHeaderBand: TSctBand;
    PageHeaderBandlevel: TSctLevel;
    DetailBand: TSctBand;
    DetailBandlevel: TSctLevel;
    PageFooterBand: TSctBand;
    PageFooterBandlevel: TSctLevel;
    ReportFooterBand: TSctBand;
    ReportFooterBandlevel: TSctLevel;
    Sctvarlabel1: TSctvarlabel;
    SctShape1: TSctShape;
    svarDateTime: TSctDateTimeVar;
    svarPage: TSctPageVar;
    varlabel: TSctvarlabel;
    varlabel1: TSctvarlabel;
    Sctvarlabel2: TSctvarlabel;
    Button1: TButton;
    SaveDialog1: TSaveDialog;
    procedure btnOpenAceFileClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    procedure AceToBmp(Acefile: TAceAceFile; BmpOutputFile: string; PageNo: Integer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  FirstPageOnly: Boolean;

resourcestring
  SFinished = 'Finished';

implementation

uses PSETUP;

{$R *.DFM}

{------------------------------------------------------------------------------}
procedure TForm1.AceToBmp(Acefile: TAceAceFile; BmpOutputFile: string; PageNo: Integer);
var
  aBmp : TBitmap;
begin
  aBmp  := TBitmap.Create;
  try
    aBmp.Height := Round(Acefile.AcePrinterSetup.Length * Screen.PixelsPerInch);
    aBmp.Width := Round(Acefile.AcePrinterSetup.Width * Screen.PixelsPerInch);
    Acefile.PlayPage(aBmp.Canvas.Handle, PageNo);
    aBmp.SaveToFile(BmpOutputFile);
  finally
    aBmp.Free;
  end;
end;

{------------------------------------------------------------------------------}
procedure TForm1.btnOpenAceFileClick(Sender: TObject);
const
  LENGTH_OF_DOT_AND_EXTENSION = 4;
var
  aFile: TAceAceFile;
  sAceFilename, sBMPFileName, SNameWithoutExtension: String;
  i: Integer;
begin
  Screen.Cursor := crHourglass;
  try
    FirstPageOnly := radgrp.ItemIndex = 0;
    if OpenDialog1.Execute then
    begin
      aFile := TAceAceFile.Create;
      try
        aFile.LoadFromFile(OpenDialog1.Filename);
        sAceFilename := OpenDialog1.Filename;
        sBMPFileName := ChangeFileExt(sAceFilename, '.bmp');
        SNameWithoutExtension := Copy(sBMPFileName, 1, length(
          sBMPFileName)-LENGTH_OF_DOT_AND_EXTENSION);
        aFile.HorzScale := 100;
        aFile.VertScale := 100;
        if FirstPageOnly then
          AceToBmp(aFile, sBMPFileName, 1)
        else
          for i := 0 to Pred(aFile.Pages.Count) do
          begin
            sBMPFileName := Format('%s%d.bmp', [SNameWithoutExtension, i+1]);
            AceToBmp(aFile, sBMPFileName, i+1);
          end;
      finally
        aFile.Free;
      end;
    end;
  finally
    Screen.Cursor := crDefault;
  end;
  ShowMessage(SFinished);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  aFile: TAceAceFile;
  sAceFilename, sBMPFileName: String;
begin
  Screen.Cursor := crHourglass;
  try
    if SaveDialog1.Execute then
    begin
      aFile := TAceAceFile.Create;
      try
        sAceFilename := 'tmp12345.ace';
        sBMPFileName := SaveDialog1.Filename;
        SctReport1.Page.PageSetup.Destination := destFile;
        SctReport1.Page.AceFileName := sAceFileName;
        SctReport1.Prompt := False;
        SctReport1.Run;
        aFile.LoadFromFile(sAceFilename);
        aFile.HorzScale := 100;
        aFile.VertScale := 100;
        AceToBmp(aFile, sBMPFileName, 1)
      finally
        aFile.Free;
      end;
    end;
  finally
    Screen.Cursor := crDefault;
  end;
  ShowMessage(SFinished);
end;

end.
